/* 
 * File:   helper_functions.h
 * Author: aj373
 *
 * Created on April 24, 2018, 12:08 AM
 */

#include "plib.h"

// De-bouncing defines
#define NoPush 0
#define MaybePush 1
#define Pushed 2
#define MaybeNoPush 3

extern int pauseScreen;
extern int clearScreen;
extern int scopeOutput;
extern int setRed;

// === the fixed point macros ======================================== CAN PUT IN CARDIAC NEURON.h
typedef signed int fix16 ;
#define multfix16(a,b) ((fix16)(((( signed long long)(a))*(( signed long long)(b)))>>16)) //multiply two fixed 16:16
#define float2fix16(a) ((fix16)((a)*65536.0)) // 2^16
#define fix2float16(a) ((float)(a)/65536.0)
#define fix2int16(a)    ((int)((a)>>16))
#define int2fix16(a)    ((fix16)((a)<<16))
#define divfix16(a,b) ((fix16)((((signed long long)(a)<<16)/(b)))) 
#define sqrtfix16(a) (float2fix16(sqrt(fix2float16(a)))) 
#define absfix16(a) abs(a)

void calculateAdc();
void checkCursorButtons();
void checkUpDownButtons(int * pauseScreen, int * screen);
void clearScreenOnce();
void debounce(int* pushState, int* buttonState, int* buttonValue);
void drawBlackBoxesFirstScreen();
void plotVoltage();
void screenInit();
void updateFirstScreenConstantText(int screenRow);
void updateSecondScreenConstantText(int screenRow, int screenColumn);
void updateFirstScreen();
void updateSecondScreen();
void updateThirdScreen();
void updateFourthScreen();
void updateScreenRow(int* screen);


